/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#include "../Framework3/OpenGL/OpenGLApp.h"
#include "../Framework3/Util/Model.h"
#include "../Framework3/Util/BSP.h"

//#define COMPUTE_LIGHTMAP
#define L_SAMPLE_COUNT 512
#define O_SAMPLE_COUNT 4096

struct Node {
	vec3 pos;
	float wx, wy;
	float exposure;
	float blurStrength;
};

class App : public OpenGLApp {
public:
	char *getTitle() const { return "HDR"; }

	void resetCamera();
	void moveCamera(const vec3 &dir);

	bool onKey(const uint key, const bool pressed);

	bool init();
	void exit();

	bool initAPI();
	bool load();
	void unload();

	void drawEnvironment(const mat4 &invMvp);
	void drawQuad();
	void drawFrame();

protected:
	TextureID envRGB, envExp;

	ShaderID skyBox;

	vec2 scaleBias;

	Image lightMapImage;
	TextureID lightMap;
	vec3 lightDir;

	Model *map;
	BSP bsp;

	vec2 size;

	SamplerStateID nearestClamp, trilinearAniso;

	TextureID base[3], bump[3];
	ShaderID lighting;

	TextureID rtColor, rtDepth, rtBlur, rtBlur2, rtBlur3;
	ShaderID convert, blur, toneMapping;

	Slider *exposureControl, *blurControl;
	CheckBox *freeFly;

	Array <Node> nodes;
};
